using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace CustomAvatarAnimation
{
    // Class stores a single keyframe in the custom avatar animation
    public struct Keyframe
    {
        // The index value of this bone in the avatar skeleton
        public int BoneIndex;
        // Time when this keyframe occurs in the animation
        public TimeSpan Time;
        // The bone transfrom
        public Matrix Transform;

        public Keyframe(int boneIndex, TimeSpan time, Matrix transform)
        {
            BoneIndex = boneIndex;
            Time = time;
            Transform = transform;
        }
    }
}
