using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace MediaSample
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        Song song;
        Texture2D texture;
        VisualizationData data;
        Color[] colorData;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            song = Content.Load<Song>("samplemusic");
            data = new VisualizationData();
            MediaPlayer.IsVisualizationEnabled = true;
            texture = new Texture2D(GraphicsDevice, 
                data.Frequencies.Count, data.Samples.Count);
            colorData = new Color[texture.Width * texture.Height];

            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here
            if (GamePad.GetState(PlayerIndex.One).Buttons.A == ButtonState.Pressed)
            {
                MediaPlayer.Stop();
                MediaPlayer.Play(song);
            }

            if (MediaPlayer.State == MediaState.Playing)
            {
                MediaPlayer.GetVisualizationData(data);
            }
            for (int x = 0; x < data.Frequencies.Count; x++)
            {
                for (int y = 0; y < data.Samples.Count; y++)
                {
                    colorData[(x * data.Frequencies.Count) + y] = 
                        new Color(data.Frequencies[x],
                            (float)Math.Asin(data.Samples[y]),
                            data.Frequencies[x] + (float)Math.Asin(data.Samples[y]));
                }
            }
            texture.SetData<Color>(colorData);

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);
            spriteBatch.Begin();
            spriteBatch.Draw(texture, GraphicsDevice.Viewport.Bounds, Color.White);
            spriteBatch.End();
            GraphicsDevice.Textures[0] = null;
            base.Draw(gameTime);
        }
    }
}
